`timescale 1 ns/1 ps

module testbench;

localparam T = 10;
localparam N = 8;

reg          test_clk;
reg  [N-1:0] test_d;
wire [N-1:0] test_q;

d_ff 
#(
   .N  (N       )
) uut (
   .clk(test_clk),
   .d  (test_d  ),
   .q  (test_q  )
);

always #T test_clk = ~test_clk;

initial begin
   test_clk = 0;
   test_d = 8'd100;
   repeat (10) @(negedge test_clk);
   @(negedge test_clk); test_d = 8'd55;
   @(negedge test_clk); test_d = 8'd200;
   repeat (10) @(negedge test_clk);
   $stop;
end

endmodule