`timescale 1 ns/1 ps

module testbench;

localparam DELAY = 100;
localparam N = 8;

reg          test_c;
reg  [N-1:0] test_d;
wire [N-1:0] test_q;

d_latch 
#(
   .N(N     )
) uut (
   .c(test_c),
   .d(test_d),
   .q(test_q)
);

initial begin
   test_c = 1'b1;
   test_d = 8'd100; #DELAY;
   test_c = 1'b0; repeat (5) #DELAY; 
   test_c = 1'b1;
   test_d = 8'd55; #DELAY;
   test_d = 8'd222; #DELAY;
   test_c = 1'b0; repeat (5) #DELAY; 
   $stop;
end

endmodule