module free_run_counter
#(
   parameter      N = 4
) (
   input          clk,
   input          rstb,
   output [N-1:0] q,
   output         max_tick
);

reg  [N-1:0] state_reg;
wire [N-1:0] state_next;

// state register
always @(posedge clk or negedge rstb) begin
   if (~rstb) state_reg <= 0;
   else       state_reg <= state_next;
end

// next-state logic
assign state_next = state_reg + 1'b1;

// output logic
assign q = state_reg;
assign max_tick = &state_reg;

endmodule