module free_run_shift_reg
#(
   parameter N = 4
) (
   input  clk,
   input  rstb,
   input  s_in,
   output s_out
);

reg  [N-1:0] state_reg;
wire [N-1:0] state_next;

// state register
always @(posedge clk or negedge rstb) begin
   if (~rstb) state_reg <= 0;
   else       state_reg <= state_next;
end

assign state_next = {s_in, state_reg[N-1:1]}; // next-state logic
assign s_out = state_reg[0];                  // output logic

endmodule