`timescale 1 ns/1 ps

module testbench;

localparam T = 10;
localparam N = 4;

reg  test_clk;
reg  test_rstb;
reg  test_s_in;
wire test_s_out;

free_run_shift_reg 
#(
   .N    (N         )
) uut (
   .clk  (test_clk  ),
   .rstb (test_rstb ),
   .s_in (test_s_in ),
   .s_out(test_s_out)
);

always #T test_clk = ~test_clk;

initial begin
   test_clk = 0;
   test_rstb = 0;
   test_s_in = 1'b0;
   @(negedge test_clk) test_rstb = 1;
   @(negedge test_clk); test_s_in = 1'b1;
   @(negedge test_clk); test_s_in = 1'b0;
   @(negedge test_clk); test_s_in = 1'b1;
   @(negedge test_clk); test_s_in = 1'b1;
   @(negedge test_clk); test_s_in = 1'b0;
   repeat (10) @(negedge test_clk);
   $stop;
end

endmodule