`timescale 1 ns/1 ps

module testbench;

localparam T = 10;
localparam M = 10;
localparam N = $clog2(M);

reg          test_clk, test_rstb;
wire [N-1:0] test_q;
wire         test_max_tick;

modm_counter_2 
#(
   .N       (N            )
) uut (
   .clk     (test_clk     ),
   .rstb    (test_rstb    ),
   .q       (test_q       ),
   .max_tick(test_max_tick)
);

always #T test_clk = ~test_clk;

initial begin
   test_clk = 0;
   test_rstb = 0;
   @(negedge test_clk) test_rstb = 1;
   repeat (23) @(negedge test_clk);
   $stop;
end

endmodule