`timescale 1 ns/1 ps

module testbench;

localparam T = 10;
localparam N = 4;

reg        test_clk, test_rstb;
reg  [3:0] test_in0, test_in1, test_in2, test_in3;
reg  [3:0] test_dp_in;
wire [3:0] test_an;
wire [7:0] test_sseg;

sseg_multiplexing 
#(
   .N    (N         )
) uut (
   .clk  (test_clk  ),
   .rstb (test_rstb ),
   .in0  (test_in0  ),
   .in1  (test_in1  ),
   .in2  (test_in2  ),
   .in3  (test_in3  ),
   .dp_in(test_dp_in),
   .an   (test_an   ),
   .sseg (test_sseg )
);

always #T test_clk = ~test_clk;

initial begin
   test_clk = 0;
   test_rstb = 0;
   test_in0 = 4'd1; test_in1 = 4'd2; test_in2 = 4'd3; test_in3 = 4'd4; test_dp_in = 4'd0;
   @(negedge test_clk) test_rstb = 1;
   repeat (23) @(negedge test_clk);
   $stop;
end

endmodule