`timescale 1 ns/1 ps

module testbench;

localparam T = 10;
localparam N = 4;

reg          test_clk, test_rstb;
reg          test_sclr, test_load, test_en, test_up;
reg  [N-1:0] test_d;
wire [N-1:0] test_q;
wire         test_max_tick, test_min_tick;

universal_counter 
#(
   .N       (N            )
) uut (
   .clk     (test_clk     ),
   .rstb    (test_rstb    ),
   .sclr    (test_sclr    ),
   .load    (test_load    ),
   .en      (test_en      ),
   .up      (test_up      ),
   .d       (test_d       ),
   .q       (test_q       ),
   .max_tick(test_max_tick),
   .min_tick(test_min_tick)
);

always #T test_clk = ~test_clk;

initial begin
   test_clk = 0;
   test_rstb = 0;
   test_sclr = 0;
   test_load = 0;
   test_en = 0;
   test_up = 0;
   test_d = 0;
   @(negedge test_clk) test_rstb = 1; test_d = 10; test_load = 1;
   @(negedge test_clk) test_load = 0; test_en = 0;
   @(negedge test_clk) test_en = 1; test_up = 1;
   repeat (10) @(negedge test_clk);
   @(negedge test_clk) test_en = 1; test_up = 0;
   repeat (3) @(negedge test_clk);
   $stop;
end

endmodule