module universal_shift_reg
#(
   parameter      N = 4
) (
   input          clk,
   input          rstb,
   input  [1:0]   ctrl,
   input  [N-1:0] d,
   output [N-1:0] q
);

reg [N-1:0] state_reg;
reg [N-1:0] state_next;

// state register
always @(posedge clk or negedge rstb) begin
   if (~rstb) state_reg <= 0;
   else       state_reg <= state_next;
end

// next-state logic
always @* begin
   case (ctrl)
      2'b00: state_next = state_reg;
      2'b01: state_next = {state_reg[N-2:0], d[0]};
      2'b10: state_next = {d[3], state_reg[N-1:1]};
      default: state_next = d;
   endcase
end

// output logic
assign q = state_reg;

endmodule