`timescale 1 ns/1 ps

module testbench;

localparam T = 10;
localparam N = 4;

reg          test_clk;
reg          test_rstb;
reg  [1:0]   test_ctrl;
reg  [N-1:0] test_d;
wire [N-1:0] test_q;

universal_shift_reg 
#(
   .N   (N        )
) uut (
   .clk (test_clk ),
   .rstb(test_rstb),
   .ctrl(test_ctrl),
   .d   (test_d   ),
   .q   (test_q   )
);

always #T test_clk = ~test_clk;

initial begin
   test_clk = 0;
   test_rstb = 0;
   test_d = 2**N-1;
   test_ctrl = 2'b00;
   @(negedge test_clk) test_rstb = 1;
   @(negedge test_clk); test_ctrl = 2'b11; // load shift register with d
   @(negedge test_clk); test_ctrl = 2'b01; test_d = 0; // shift left
   @(negedge test_clk);
   @(negedge test_clk); test_ctrl = 2'b10; test_d = 8; // shift right
   @(negedge test_clk);
   @(negedge test_clk); test_ctrl = 2'b00; // keep shift register value
   repeat (3) @(negedge test_clk);
   $stop;
end

endmodule